链接

君子,修身齐家,治国平天下。

题意:

Pchelyonok决定给Mila一件礼物。Pchelyonok已经“买”了一个长度为 n 的数组 a,但他觉得送一个数组太普通了。他决定将这个数组中的一些区间送给Mila!

Pchelyonok想让他的礼物更漂亮,因此他决定从数组选择 k 个不相交的区间,满足:

第一个区间的长度是 k,第二个区间的长度是 k-1,…,第 k 个区间的长度是 1。

对任意Codeforces Round #750 (Div. 2)E. Pchelyonok and Segments (数学+DP)_DP,第 Codeforces Round #750 (Div. 2)E. Pchelyonok and Segments (数学+DP)_DP_02 个区间在第 Codeforces Round #750 (Div. 2)E. Pchelyonok and Segments (数学+DP)_DP_03 个区间左边。(即 Codeforces Round #750 (Div. 2)E. Pchelyonok and Segments (数学+DP)_DP_04

这些区间内的数之和严格单调递增。(用符号语言说就是:令 Codeforces Round #750 (Div. 2)E. Pchelyonok and Segments (数学+DP)_#define_05 ,则 Codeforces Round #750 (Div. 2)E. Pchelyonok and Segments (数学+DP)_i++_06
Pchelenok希望他的礼物尽可能漂亮,所以他请你找到满足上述条件的 k 的最大值。

分析:

首先肯定是从后往前分析:为什么那?因为我们肯定从长度短的转移到长度长的。怎么转移那?无非就是找到连续长度大一的,区间和小的。然后我们看下转移方程:
Codeforces Round #750 (Div. 2)E. Pchelyonok and Segments (数学+DP)_#define_07
Codeforces Round #750 (Div. 2)E. Pchelyonok and Segments (数学+DP)_数组_08表示第i位置,长度为j是否合法。

/// 欲戴皇冠,必承其重。
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<ll, ll> pii;
typedef unsigned long long ull;

#define x first
#define y second
#define PI acos(-1)
#define inf 0x3f3f3f3f
#define lowbit(x) ((-x)&x)
#define debug(x) cout << #x <<": " << x << endl;

const int MOD = 998244353;
const int mod = 998244353;
const int N = 1e5 + 10;
const int dx[] = {0, 1, -1, 0, 0, 0, 0};
const int dy[] = {0, 0, 0, 1, -1, 0, 0};
const int dz[] = {0, 0, 0, 0, 0, 1, -1};
int day[] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

ll n, m,p;
ll a[N],b[N];
ll dp[N][500];

void solve()
{
cin>>n;
for(int i=1;i<=n;i++){
cin>>a[i];
b[i]=b[i-1]+a[i];
}
for(int i=1;i*i<=((n+1)*2);i++) dp[n+1][i]=-1e16;
dp[n+1][0]=1e16;
for(int i=n;i>=1;i--){
for(int j=0;j*j<=((n+1)*2);j++){
dp[i][j]=dp[i+1][j];
if(j&&i+j-1<=n&&b[j+i-1]-b[i-1]<dp[i+j][j-1]) dp[i][j]=max(dp[i][j],b[i+j-1]-b[i-1]);
}
}
for(int i=sqrt((n+1)*2);;i--){
if(dp[1][i]>0) {
cout<<i<<endl;
return ;
}
}
}
int main()
{
ll t = 1;
scanf("%lld", &t);
while(t--)
{
solve();
}
return 0;
}